/**
 * Created by IntelliJ IDEA.
 * User: camillej
 * Date: 13/12/11
 * Time: 11:21
 * To change this template use File | Settings | File Templates.
 */
package org.ow2.orchestra.designer.events {
import org.ow2.orchestra.designer.bpmn.model.data.type.XSDElementModel;
import org.ow2.orchestra.designer.model.ProcessEditorModel;

public class DataTypesChangeEvent extends ProcessEvent {

  /**
   * Add a datatype file.
   */
  public static const DATA_TYPE_ADD:String = "DataTypesEvent_AddDataType";

  /**
   * Delete a datatype.
   */
  public static const DATA_TYPE_DELETE:String = "DataTypesEvent_DeleteDataType";

  private var _elementName:String;
  private var _typeQName:String;
  private var _elementModel:XSDElementModel;

  public function DataTypesChangeEvent(type:String, processEditorModel:ProcessEditorModel,
                                       elementName:String = null, typeQName:String = null,
                                       elementModel:XSDElementModel = null,
                                       bubbles:Boolean = false, cancelable:Boolean = false) {
    super(type, processEditorModel, bubbles, cancelable);
    _elementName = elementName;
    _typeQName = typeQName;
    _elementModel = elementModel;
  }

  /**
   * Only available for DATA_TYPE_ADD
   */
  public function get elementName():String {
    return _elementName;
  }

  /**
   * Only available for DATA_TYPE_ADD
   */
  public function get typeQName():String {
    return _typeQName;
  }

  /**
   * Only available for DATA_TYPE_DELETE
   */
  public function get elementModel():XSDElementModel {
    return _elementModel;
  }
}
}
