/**
 * Bull SAS / OW2 Orchestra
 * Copyright (C) 2010 Bull S.A.S, and individual contributors as indicated
 * by the @authors tag.
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
 * USA
 */
package org.ow2.orchestra.designer.events {
import mx.collections.ArrayCollection;

import org.ow2.orchestra.designer.model.DiagramEditorModel;

import org.ow2.orchestra.designer.model.ProcessEditorModel;

  public class DiagramElementsSelectionCoordinatesChangeEvent extends DiagramEvent {

    /**
     * Update list of selected process element.
     */
    public static const COORDINATES_CHANGE:String = "DiagramElementsSelectionCoordinatesChangeEvent_ChangeCoordinates";

    //A collection of elementMove
    private var _elementsMove:ArrayCollection;

    public function DiagramElementsSelectionCoordinatesChangeEvent(type:String, diagramEditorModel:DiagramEditorModel,
            elementsMove:ArrayCollection, bubbles:Boolean = false, cancelable:Boolean = false) {
      super(type, diagramEditorModel, bubbles, cancelable);
     _elementsMove = elementsMove;
    }


    public function get elementsMove():ArrayCollection {
      return _elementsMove;
    }
  }
}
