/**
 * Bull SAS / OW2 Orchestra
 * Copyright (C) 2010 Bull S.A.S, and individual contributors as indicated
 * by the @authors tag.
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
 * USA
 */
package org.ow2.orchestra.designer.events {
  import org.ow2.orchestra.designer.bpmn.model.AbstractElementWithPosition;
import org.ow2.orchestra.designer.model.DiagramEditorModel;
import org.ow2.orchestra.designer.model.ProcessEditorModel;

  public class DiagramModificationEvent extends DiagramEvent {
    /**
     * Add a process element.
     */
    public static const DIAGRAM_ELEMENT_ADD:String = "ProcessModificationEvent_AddProcessElement";
    public static const DIAGRAM_ELEMENT_ADD_WITH_SEQUENCE:String = "ProcessModificationEvent_AddProcessElementWithSequence";

    private var _modelElement:AbstractElementWithPosition;
    private var _sourceElement:AbstractElementWithPosition;
    private var _element_pos_x:int;
    private var _element_pos_y:int;

    public function DiagramModificationEvent(type:String, diagramEditorModel:DiagramEditorModel, modelElement:AbstractElementWithPosition, element_pos_x:int, element_pos_y:int, sourceElement:AbstractElementWithPosition = null, bubbles:Boolean = false, cancelable:Boolean = false) {
      super(type, diagramEditorModel, bubbles, cancelable);
      _modelElement = modelElement;
      _sourceElement = sourceElement;
      _element_pos_x = element_pos_x;
      _element_pos_y = element_pos_y;
    }

    public function get modelElement():AbstractElementWithPosition {
      return _modelElement;
    }

    public function get sourceElement():AbstractElementWithPosition {
      return _sourceElement;
    }

    public function get element_pos_x():int {
      return _element_pos_x;
    }

    public function get element_pos_y():int {
      return _element_pos_y;
    }
  }
}
