/**
 * Bull SAS / OW2 Orchestra
 * Copyright (C) 2011 Bull S.A.S, and individual contributors as indicated
 * by the @authors tag.
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
 * USA
 */
package org.ow2.orchestra.designer.model {
import mx.controls.Image;

/**
 * this class is designed to hold data representing drag and drop action of a palette element.
 * @author Loic Albertin
 */
public class ElementPaletteDnDModel {
  private var _deltaX:int;
  private var _deltaY:int;
  private var _image:Image;

  public function ElementPaletteDnDModel(deltaX:int, deltaY:int, image:Image) {
    _deltaX = deltaX;
    _deltaY = deltaY;
    _image = image;
  }

  /**
   * The delta on x-axis between mouse click and top left corner of the image
   * (ie where the element will be actually dropped).
   */
  public function get deltaX():int {
    return _deltaX;
  }

  /**
   * The delta on y-axis between mouse click and top left corner of the image
   * (ie where the element will be actually dropped).
   */
  public function get deltaY():int {
    return _deltaY;
  }

  /**
   * The element image used to compute drop acceptance.
   */
  public function get image():Image {
    return _image;
  }
}
}
