/**
 * Bull SAS / OW2 Orchestra
 * Copyright (C) 2010 Bull S.A.S, and individual contributors as indicated
 * by the @authors tag.
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
 * USA
 */
package org.ow2.orchestra.designer.model {
import org.ow2.orchestra.designer.bpmn.model.process.ProcessModel;
import org.ow2.orchestra.designer.vo.FileNavigatorProcess;

[Bindable]
public class ProcessEditorModel extends DiagramEditorModel {

  //Path of the file on the server to store the process
  private var _fileNavigatorProcess:FileNavigatorProcess;

  //indicate if the process is editing in writing or no, by default true;
  private var _readWrite:Boolean;


  public function ProcessEditorModel() {
    super(new ProcessModel());
    _readWrite = true;
  }


  public function get processModel():ProcessModel {
    return ProcessModel(diagramModel);
  }

  public function set processModel(value:ProcessModel):void {
    diagramModel = value;
  }

  public function get fileNavigatorProcess():FileNavigatorProcess {
    return DesignerModelLocator.getInstance().fileNavigatorModel.getProcess(_fileNavigatorProcess);
  }

  public function set fileNavigatorProcess(value:FileNavigatorProcess):void {
    _fileNavigatorProcess = value;
  }

  public function set readWrite(readWrite:Boolean):void {
    _readWrite = readWrite;
  }

  public function get readWrite():Boolean {
    return _readWrite;
  }
}
}
