package org.ow2.orchestra.designer.view {
import flash.display.DisplayObjectContainer;

import flexlib.controls.ScrollableArrowMenu;

import mx.controls.Menu;

import mx.core.Application;

/**
 * @author Loic Albertin
 *
 * Warning: This class is designed to workaround the infinite loop issue when using ScrollableMenu and Flex 3.x.
 * See {@link http://code.google.com/p/flexlib/issues/detail?id=271}
 * The workaround is quite ugly but limits code duplication.
 *
 * TODO: move the whole Designer to Flex 4, use FlexLib >= 3.6 and remove this class
 */
public class PatchedScrollableArrowMenu extends ScrollableArrowMenu {

  private var _hackInProgress:Boolean = false;

  public function PatchedScrollableArrowMenu() {
    super();
  }

  /**
   * We have to override the static function createMenu so that we create a
   * ScrollableMenu instead of a normal Menu.
   */
  public static function createMenu(parent:DisplayObjectContainer, mdp:Object, showRoot:Boolean = true):PatchedScrollableArrowMenu {
    var menu:PatchedScrollableArrowMenu = new PatchedScrollableArrowMenu();
    menu.tabEnabled = false;

    menu.owner = DisplayObjectContainer(Application.application);
    menu.showRoot = showRoot;
    popUpMenu(menu, parent, mdp);
    return menu;
  }


  override protected function createSubMenu():Menu {
    return new PatchedScrollableArrowMenu();
  }

  /**
   * We overide the <code>measure()</code> method because we need to check if the menu is going off
   * the stage. If it's going to be too high, then we make it smaller to keep it from
   * going off. I also stuck in a buffer of 10 pixels from the bottom of the stage.
   *
   * We also check if we're showing the vertical scrollbar, and if so we adjust the
   * width to account for that.
   */
  override protected function measure():void {
    this._hackInProgress = true;
    super.measure();
    this._hackInProgress = false;
  }


  override public function invalidateProperties():void {
    if (!_hackInProgress) {
      super.invalidateProperties();
    }
  }
}
}
