/*
 * Bull SAS / OW2 Orchestra
 * Copyright (C) 2011 Bull S.A.S, and individual contributors as indicated
 * by the @authors tag.
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
 * USA
 */

/**
 * Created by ${PRODUCT_NAME}.
 * User: porcherg
 * Date: 09/02/11
 * Time: 17:00
 * To change this template use File | Settings | File Templates.
 */
package org.ow2.orchestra.designer.view.diagramEditor {
import flash.events.Event;
import flash.geom.Point;

import mx.core.UIComponent;
import mx.events.FlexEvent;
import mx.events.MoveEvent;
import mx.events.PropertyChangeEvent;

import org.ow2.orchestra.designer.bpmn.views.FlowView;

public class FlowSelectionAnchor extends UIComponent {
  private var _isSource:Boolean;
  private var flowView:FlowView;

  public function FlowSelectionAnchor(flowView:FlowView, tracksSourceElement:Boolean) {
    super();
    this._isSource = tracksSourceElement;
    this.flowView = flowView;

    flowView.addEventListener(PropertyChangeEvent.PROPERTY_CHANGE, modified);
    this.addEventListener(MoveEvent.MOVE, redrawOnEvent);

    this.addEventListener(FlexEvent.CREATION_COMPLETE, onCreationComplete);
  }

  private function onCreationComplete(event:Event):void {
    redrawOnEvent(event);
    this.removeEventListener(FlexEvent.CREATION_COMPLETE, onCreationComplete);
  }

  private function redrawOnEvent(event:Event):void {
    if (_isSource) {
      redraw(flowView.sourcePoint);
    } else {
      redraw(flowView.targetPoint);
    }
  }

  private function modified(event:PropertyChangeEvent):void {
    if (event.property == "_sourcePoint" && _isSource) {
      var sourcePoint:Point = event.newValue as Point;
      redraw(sourcePoint);
    } else if (event.property == "_targetPoint" && !_isSource) {
      var targetPoint:Point = event.newValue as Point;
      redraw(targetPoint);
    }

  }

  private function redraw(point:Point):void {
    var localPoint:Point = this.globalToLocal(flowView.localToGlobal(point));
    this.graphics.clear();
    this.graphics.lineStyle(1);
    this.graphics.beginFill(0x000000);
    this.graphics.drawCircle(localPoint.x, localPoint.y, 4);
  }

  public function get isSource():Boolean {
    return _isSource;
  }
}
}
