/**
 * Bull SAS / OW2 Orchestra
 * Copyright (C) 2010 Bull S.A.S, and individual contributors as indicated
 * by the @authors tag.
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
 * USA
 */
package org.ow2.orchestra.designer.view.palette.bpmn {
import org.act.od.impl.other.Localizator;
import org.ow2.orchestra.designer.view.palette.*;

public class BpmnPalette extends AbstractPalette {
  /**
   * The source for "palette" image data binding.
   */
  [Embed(source="/../assets/icon/container/palette.gif")]
  public static const palette:Class;

  public function BpmnPalette() {
    this.icon = palette;
    this.toolTip = Localizator.getInstance().getText('palette.label');

    var gatewayView:GatewayPaletteView = new GatewayPaletteView(this);
    gatewayView.automationName = "paletteGatewayView";
    this.addElementToPalette(gatewayView);

    var eventView:EventPaletteView = new EventPaletteView(this);
    eventView.automationName = "paletteEventView";
    this.addElementToPalette(eventView);

    var task:TaskPaletteView = new TaskPaletteView(this);
    task.automationName = "paletteTaskView";
    this.addElementToPalette(task);
  }


}
}
