/**
 * @author Loic Albertin
 */
package org.ow2.orchestra.designer.view.palette.datamapping {
import mx.containers.BoxDirection;
import mx.controls.VRule;
import mx.core.ScrollPolicy;

import org.ow2.orchestra.designer.view.palette.AbstractPalette;

public class DataMappingPalette extends AbstractPalette {
  public function DataMappingPalette() {
    super();

    this.direction = BoxDirection.HORIZONTAL;
    this.verticalScrollPolicy = ScrollPolicy.OFF;

    this.setStyle("borderStyle", "solid");
    this.setStyle("borderThickness", "2");
    this.percentWidth = 100;
    this.height = 40;

    var padding:String = "2";
    var inputDataPaletteView:DataObjectPaletteView = new DataObjectPaletteView(this);
    inputDataPaletteView.automationName = "dmPaletteInputDataView";
    inputDataPaletteView.horizontalScrollPolicy = inputDataPaletteView.verticalScrollPolicy = ScrollPolicy.OFF;
    inputDataPaletteView.setStyle("paddingBottom", padding);
    inputDataPaletteView.setStyle("paddingLeft", padding);
    inputDataPaletteView.setStyle("paddingRight", padding);
    inputDataPaletteView.setStyle("paddingTop", padding);

    this.addElementToPalette(inputDataPaletteView);

    var vRule:VRule = new VRule();
    vRule.setStyle("strokeWidth", "5");
    vRule.width = 2;
    vRule.height = 40;
    this.addChild(vRule);

    var outputDataPaletteView:DataInputPaletteView = new DataInputPaletteView(this);
    outputDataPaletteView.automationName = "dmPaletteOutputDataView";
     outputDataPaletteView.horizontalScrollPolicy = outputDataPaletteView.verticalScrollPolicy = ScrollPolicy.OFF;
    outputDataPaletteView.setStyle("paddingBottom", padding);
    outputDataPaletteView.setStyle("paddingLeft", padding);
    outputDataPaletteView.setStyle("paddingRight", padding);
    outputDataPaletteView.setStyle("paddingTop", padding);
    this.addElementToPalette(outputDataPaletteView);

  }
}
}
