/**
 * Created by ${PRODUCT_NAME}.
 * User: camillej
 * Date: 24/02/11
 * Time: 13:59
 * To change this template use File | Settings | File Templates.
 */
package org.ow2.orchestra.designer.view.processEditor {
import flash.events.MouseEvent;

import mx.collections.ArrayCollection;

import org.ow2.orchestra.designer.bpmn.model.AbstractElement;
import org.ow2.orchestra.designer.bpmn.model.AbstractElementWithPosition;
import org.ow2.orchestra.designer.bpmn.model.process.GatewayModel;
import org.ow2.orchestra.designer.bpmn.model.process.PoolModel;
import org.ow2.orchestra.designer.bpmn.model.process.SequenceFlowModel;
import org.ow2.orchestra.designer.bpmn.model.process.TaskModel;
import org.ow2.orchestra.designer.view.diagramEditor.*;

public class ProcessEditorSequenceFlowStateUtil extends DiagramEditorFlowStateUtil {


  public function ProcessEditorSequenceFlowStateUtil(diagramEditorView:AbstractDiagramEditorView) {
    super(diagramEditorView);
  }


  public override function allowFlowTarget(mouseEvent:MouseEvent):Boolean {
    if (super.allowFlowTarget(mouseEvent)) {

      var listSelectedElements:ArrayCollection = new ArrayCollection();
      listSelectedElements = getElementUnderMouse(mouseEvent);
      // only one selected element.
      var selectedElement:AbstractElementWithPosition = listSelectedElements.getItemAt(0) as AbstractElementWithPosition;
      if (selectedElement is GatewayModel) {
        return true;
      }
      var elementSource:AbstractElement =
          diagramEditorView.diagramEditorModel.selectedElements.getItemAt(0) as AbstractElement;
      var sequenceFlowModel:SequenceFlowModel = null;
      if (elementSource != null && elementSource is SequenceFlowModel) {
        sequenceFlowModel = elementSource as SequenceFlowModel;
        elementSource = sequenceFlowModel.sourceElement;
      }
      if (selectedElement is PoolModel) {
        if (sequenceFlowModel != null) {
          // cannot move an existing sequenceFlow to a pool
          return false;
        }
        return elementSource is TaskModel;
      } else {
        if (sequenceFlowModel != null) {
          // case of moving an existing sequence flow
          return selectedElement.incomingFlows.length < 1 || selectedElement == sequenceFlowModel.targetElement;
        } else if (elementSource is TaskModel) {
          // case of creation a new sequence flow
          // for task model check there is not already a sequence flow
          return (elementSource as TaskModel).outgoingFlows.length < 1;
        }
        return selectedElement.incomingFlows.length < 1;
      }
    }
    return false;
  }

  public override function allowFlowSource(mouseEvent:MouseEvent):Boolean {
    if (super.allowFlowSource(mouseEvent)) {
      var listSelectedElements:ArrayCollection = new ArrayCollection();
      listSelectedElements = getElementUnderMouse(mouseEvent);

      // only one selected element.
      var selectedElement:AbstractElementWithPosition = listSelectedElements.getItemAt(0) as AbstractElementWithPosition;
      if (selectedElement is GatewayModel) {
        return true;
      }
      if (selectedElement is PoolModel) {
        return false;
      } else {
        var sequenceFlowModel:SequenceFlowModel = diagramEditorView.diagramEditorModel.selectedElements.getItemAt(0) as SequenceFlowModel;
        if (sequenceFlowModel != null) {
          return selectedElement.outgoingFlows.length < 1 || selectedElement == sequenceFlowModel.sourceElement;
        }
        return selectedElement.outgoingFlows.length < 1;
      }
    }
    return false;
  }

}
}
